!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Calculates averaged (over angles) metric quantities at arbitrary radial location.
!latex \item The relevant information is stored in \verb+agl(1:7,1:mn*mn)+, which is passed through global.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine me00ab( lss ) 

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, quarter, pi2
  use numerical, only :
  use fileunits, only : ounit
  use inputlist, only : Wme00ab, Ni, Lsymagl
  use cputiming, only : Tme00ab
  use allglobal, only : myid, cpus, iss, ll, pi2nfp, &
                        mn, im, in, mne, ime, ine, &
                        isr, Nt, Nz, Ntz, ijimag, trigm, trign, trigwk, efmn, ofmn, cfmn, sfmn, &
                        gij, sg, glmn, &
                        agss, agst, agsz, agtt, agtz, agzz, agoo, &
                        sgl, trigfac, srigfac, pi2pi2nfpquarter

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  REAL, intent(in) :: lss 
  
  INTEGER          :: ii, ij, ik, ifail, Lcurv, jk, kj

  BEGIN(me00ab)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  FATAL(me00ab,lss.lt.iss(ll-1) .or. lss.gt.iss(ll))

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  ADDCPU(me00ab)

!latex \item The routine \verb+co01aa+ is called to provide \verb+sg(:)+, \verb+gij(1:6,0,:)+. These are passed through \verb+globals+.

  Lcurv=1 ; CALL(co01aa,(lss,Lcurv))

  RESETCPU

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item A fast Fourier transform is constructed, with an enhanced resolution, of the following metric quantities:
  
  do ii = 1,6 ; gij(ii,0,:) = gij(ii,0,:) / sg(0,:)
  enddo
  
  glmn = zero

!latex \be \bar g_{\s\s} & \equiv & \sqrt g^{-1} g_{\s\s} = \sum_i (\sqrt g^{-1} g_{\s\s})_i \cos(\alpha_i), \\
!latex     \bar g_{\s\t} & \equiv & \sqrt g^{-1} g_{\s\t} = \sum_i (\sqrt g^{-1} g_{\s\t})_i \sin(\alpha_i), \\
!latex     \bar g_{\s\z} & \equiv & \sqrt g^{-1} g_{\s\z} = \sum_i (\sqrt g^{-1} g_{\s\z})_i \sin(\alpha_i), \\
!latex     \bar g_{\t\t} & \equiv & \sqrt g^{-1} g_{\t\t} = \sum_i (\sqrt g^{-1} g_{\t\t})_i \cos(\alpha_i), \\
!latex     \bar g_{\t\z} & \equiv & \sqrt g^{-1} g_{\t\z} = \sum_i (\sqrt g^{-1} g_{\t\z})_i \cos(\alpha_i), \\
!latex     \bar g_{\z\z} & \equiv & \sqrt g^{-1} g_{\z\z} = \sum_i (\sqrt g^{-1} g_{\z\z})_i \cos(\alpha_i),
!latex \ee
!latex where $\alpha_i\equiv m_i\t-n_i\z$.

  ifail = 0 ; call tfft( Nt,Nz , gij(1,0,1:Ntz),gij(2,0,1:Ntz) ,isr,trigm,trign,trigwk, mne,ime,ine, glmn(1,1:mne),   ofmn(1:mne),   cfmn(1:mne), glmn(2,1:mne), ifail )
  ifail = 0 ; call tfft( Nt,Nz , gij(3,0,1:Ntz),gij(4,0,1:Ntz) ,isr,trigm,trign,trigwk, mne,ime,ine,   efmn(1:mne), glmn(3,1:mne), glmn(4,1:mne),   sfmn(1:mne), ifail )
  ifail = 0 ; call tfft( Nt,Nz , gij(5,0,1:Ntz),gij(6,0,1:Ntz) ,isr,trigm,trign,trigwk, mne,ime,ine, glmn(5,1:mne),   ofmn(1:mne), glmn(6,1:mne),   sfmn(1:mne), ifail ) 
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  do ij = 1,mn
   do ik = 1,mn ; jk = ik + (ij-1) * mn ; kj = ij + (ik-1) * mn
    
    if( Lsymagl ) then
     
     if( ik.ge.ij ) then
      
      sgl(1,jk) = sum( glmn(1,1:mne) * srigfac(1,1:mne,jk) ) * pi2pi2nfpquarter
      sgl(2,jk) = sum( glmn(2,1:mne) * srigfac(2,1:mne,jk) ) * pi2pi2nfpquarter 
      sgl(3,jk) = sum( glmn(2,1:mne) * srigfac(3,1:mne,jk) ) * pi2pi2nfpquarter
      sgl(4,jk) = sum( glmn(3,1:mne) * srigfac(2,1:mne,jk) ) * pi2pi2nfpquarter
      sgl(5,jk) = sum( glmn(3,1:mne) * srigfac(3,1:mne,jk) ) * pi2pi2nfpquarter
      sgl(6,jk) = sum( glmn(4,1:mne) * srigfac(4,1:mne,jk) ) * pi2pi2nfpquarter
      sgl(7,jk) = sum( glmn(5,1:mne) * srigfac(4,1:mne,jk) ) * pi2pi2nfpquarter
      sgl(8,jk) = sum( glmn(6,1:mne) * srigfac(4,1:mne,jk) ) * pi2pi2nfpquarter
      sgl(9,jk) =                      srigfac(4,1    ,jk)   * pi2pi2nfpquarter
      
      agss(jk) = sgl(1,jk)
      agst(jk) = sgl(2,jk) + sgl(3,jk)
      agsz(jk) = sgl(4,jk) + sgl(5,jk)
      agtt(jk) = sgl(6,jk)
      agtz(jk) = sgl(7,jk)
      agzz(jk) = sgl(8,jk)
      agoo(jk) = sgl(9,jk)
      
     else ! exploit symmetry to reduce computation; should also use symmetry to reduce memory;
      
      agss(jk) = sgl(1,kj)
      agst(jk) = sgl(2,kj) - sgl(3,kj)
      agsz(jk) = sgl(4,kj) - sgl(5,kj)
      agtt(jk) = sgl(6,kj)
      agtz(jk) = sgl(7,kj)
      agzz(jk) = sgl(8,kj)
      agoo(jk) = sgl(9,kj)
      
     endif ! end of if( ik.ge.ij ) ;

    else ! matches if( Lsymagl ) ;
     
     agss(jk) = sum( glmn(1,1:mne) * trigfac(1,1:mne,jk) ) * pi2pi2nfpquarter
     agst(jk) = sum( glmn(2,1:mne) * trigfac(2,1:mne,jk) ) * pi2pi2nfpquarter
     agsz(jk) = sum( glmn(3,1:mne) * trigfac(2,1:mne,jk) ) * pi2pi2nfpquarter
     agtt(jk) = sum( glmn(4,1:mne) * trigfac(4,1:mne,jk) ) * pi2pi2nfpquarter
     agtz(jk) = sum( glmn(5,1:mne) * trigfac(4,1:mne,jk) ) * pi2pi2nfpquarter
     agzz(jk) = sum( glmn(6,1:mne) * trigfac(4,1:mne,jk) ) * pi2pi2nfpquarter
     agoo(jk) =                      trigfac(4,1    ,jk)   * pi2pi2nfpquarter
     
    endif ! end of if( Lsymagl ) ;
    
   enddo
  enddo
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( Wme00ab ) then ! check symmetries;

   do ij = 1,mn
    do ik = 1,mn ; jk = ik + (ij-1) * mn ; kj = ij + (ik-1) * mn
     
     write(ounit,'("me00ab : agl(1:7,jk)="9es23.15" ;")')agss(jk),agst(jk)           ,agsz(jk)           ,agtt(jk),agtz(jk),agzz(jk),agoo(jk)
     write(ounit,'("me00ab : sgl(1:7,jk)="9es23.15" ;")')sgl(1,jk),sgl(2,jk)+sgl(3,jk),sgl(4,jk)+sgl(5,jk),sgl(6,jk),sgl(7,jk),sgl(8,jk),sgl(9,jk)
     write(ounit,'("me00ab : sgl(1:7,kj)="9es23.15" ;")')sgl(1,kj),sgl(2,kj)-sgl(3,kj),sgl(4,kj)-sgl(5,kj),sgl(6,kj),sgl(7,kj),sgl(8,kj),sgl(9,kj)
     
    enddo
   enddo

  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(me00ab)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item The following quantities are returned :
!latex \be \mbox{\type{agss(j,k)}}&=&
!latex \mbox{$\braket{s_j}{\bar g_{\s\s}}{s_k}$} = 
!latex \int_0^{2\pi} \!\!\!\!\!\!\! d\theta \int_0^{2\pi/N} \!\!\!\!\!\!\!\!\!\!\!\! d\zeta \; \; \sin(\alpha_j)  \; \; \bar g_{\s\s} \; \; \sin(\alpha_k) , \\
!latex     \mbox{\type{agst(j,k)}}&=&\mbox{$\braket{s_j}{\bar g_{\s\t}}{c_k}$}, \\
!latex     \mbox{\type{agsz(j,k)}}&=&\mbox{$\braket{s_j}{\bar g_{\s\z}}{c_k}$}, \\
!latex     \mbox{\type{agtt(j,k)}}&=&\mbox{$\braket{c_j}{\bar g_{\t\t}}{c_k}$}, \\
!latex     \mbox{\type{agtz(j,k)}}&=&\mbox{$\braket{c_j}{\bar g_{\t\z}}{c_k}$}, \\
!latex     \mbox{\type{agzz(j,k)}}&=&\mbox{$\braket{c_j}{\bar g_{\z\z}}{c_k}$}, \\
!latex     \mbox{\type{agoo(j,k)}}&=&\mbox{$\braket{c_j}{\;   1 \; }{c_k}$}. 
!latex \ee

!latex \item The following are manifestly symmetric
!latex \be \mbox{\type{agss(j,k)}}=\mbox{\type{agss(k,j)}}, \\
!latex     \mbox{\type{agtt(j,k)}}=\mbox{\type{agtt(k,j)}}, \\
!latex     \mbox{\type{agtz(j,k)}}=\mbox{\type{agtz(k,j)}}, \\
!latex     \mbox{\type{agzz(j,k)}}=\mbox{\type{agzz(k,j)}}. \ee
!latex The remaining terms may be represented as a sum of symmetric and asymmetric terms.
!latex The double angle formulae:
!latex \be \sin \alpha \cos \beta &=& \frac{1}{2}\left[\sin(\alpha-\beta)+\sin(\alpha+\beta)\right],\\
!latex     \sin \alpha \sin \beta &=& \frac{1}{2}\left[\cos(\alpha-\beta)-\cos(\alpha+\beta)\right],\ee

!latex \item Having an enhanced Fourier representation of eg. 
!latex $\bar g_{ss}=\sum_p (\bar g_{ss})_p \cos(m_p\theta-n_p\zeta)$, 
!latex triple-angle formulae are used to calculate $\braket{s_j}{\bar g_{\s\s}}{s_k}$ etc.
!latex An enhanced Fourier resolution is required as the metric elements involve products of Fourier summations.
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine me00ab

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
