!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Performs radial interpolation of vector potential harmonics.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine sa00aa( lss )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, one
  use numerical, only : vsmall
  use fileunits, only : ounit
  use inputlist, only : Wsa00aa, Ni, Nofe, Lradial
  use cputiming, only : Tsa00aa
  use allglobal, only : myid, mn, im, in, ll, ss, iss, dss, At, Az, cpus, Atmn, Azmn

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  REAL, intent(in) :: lss

  INTEGER          :: ii, ij, il, ip, id, imn, mm, itz
  REAL             :: xx, vphi(0:1,0:3,0:2), smvp(0:2), expmm

  BEGIN(sa00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  FATALMESS(sa00aa,Nofe.gt.3,need to change dimensions of vphi if higher order finite-element basis functions are employed)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Wsa00aa ) then ; cput = MPI_WTIME() ; write(ounit,'("sa00aa : "f10.2" : ll="i3" ; [s_{l-1},lss,s_{l}]="3es23.15" ;")')cput-cpus,ll,ss(ll)%s(0),lss,ss(ll)%s(Ni(ll))
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  FATALMESS(sa00aa,lss.lt.vsmall .or. lss.lt.iss(ll-1) .or. lss.gt.iss(ll),radial coordinate outside local bounds)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  ii = ( lss - iss(ll-1) ) / dss(ll,1) ! left grid point;

  if( Wsa00aa ) write(ounit,'("sa00aa : "f10.2" : ll="i3" ; ii="i3" ; [s_{l,i},lss,s_{l,i+1}]="3es23.15" ;")')cput-cpus,ll,ii,ss(ll)%s(ii),lss,ss(ll)%s(ii+1)

  FATALMESS(sa00aa,ii.lt.0,local interpolation variable outside bounds)
  
  if( ii.eq.Ni(ll) ) ii = ii-1 ! keep off outer boundary; see ii+il logic below;

  FATALMESS(sa00aa,ii.ge.Ni(ll),local interpolation variable outside bounds)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  xx = ( lss - ss(ll)%s(ii) ) / dss(ll,1) ! local interpolation;

  if( Wsa00aa ) write(ounit,'("sa00aa : "f10.2" : ll="i3" ; ii="i3" ; xx="es23.15" ;")')cput-cpus,ll,ii,xx

  FATALMESS(sa00aa,xx.lt.zero-vsmall.or.xx.gt.one+vsmall,local interpolation variable outside bounds)

  xx = min( max(xx,zero) , one )
  
 !if( xx.lt.zero ) xx = zero ! must be due to finite precision given above check on input value of lss;
 !if( xx.gt.one  ) xx = one  ! must be due to finite precision given above check on input value of lss;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  Atmn(0:2,1:mn) = zero ; Azmn(0:2,1:mn) = zero

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The routine \verb+fe00ab+ is called to perform the basis function interpolation.

  ADDCPU(sa00aa)

  CALL(fe00ab,(xx,Nofe,vphi(0:1,0:3,0:2))) ! xx is the local interpolation coordinate; 

  RESETCPU
  
  do ip = 0 , Nofe
   do id = 0 , 2
    vphi(0:1,ip,id) = vphi(0:1,ip,id) * dss(ll,ip-id) ! include radial scaling factor;
   enddo
  enddo
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The interpolated harmonics and the first and second radial derivatives are returned through the global arrays \verb+Atmn(0:2,1:mn)+ and \verb+Azmn(0:2,1:mn)+.

  do imn = 1 , mn ; ij = imn ; mm = im(ij) ! loop over Fourier harmonics;
   do ip = 0 , Nofe ! order of derivative;
    do il = 0 , 1 ! left/right;
     
     FATALMESS(sa00aa,ii+il.gt.Ni(ll),sub-grid indexing error on At and Az)
     
     if( ll.eq.1 ) then ! need to include additional "regularity" radial factor, and take it's derivative;
      
      expmm = mm * one/Lradial
      
      smvp(0) = vphi(il,ip,0) * lss**(expmm  )
      smvp(1) = vphi(il,ip,1) * lss**(expmm  ) + vphi(il,ip,0) * lss**(expmm-1) * (expmm  )
      smvp(2) = vphi(il,ip,2) * lss**(expmm  ) + vphi(il,ip,1) * lss**(expmm-1) * (expmm  ) * 2 + vphi(il,ip,0) * lss**(expmm-2) * (expmm  ) * (expmm-1)
      
     else ! matches if( ll.eq.1);
      
      smvp(0) = vphi(il,ip,0) ! no additional radial factor is included;
      smvp(1) = vphi(il,ip,1)
      smvp(2) = vphi(il,ip,2)
      
     endif ! end of if( ll.eq.1 );
     
     Atmn(0:2,imn) = Atmn(0:2,imn) + At(ll,ij,ip)%s(ii+il) * smvp(0:2)
     Azmn(0:2,imn) = Azmn(0:2,imn) + Az(ll,ij,ip)%s(ii+il) * smvp(0:2)
     
    enddo ! do il = 0 , 1 ;
   enddo ! end of do ip = 0 , Nofe;
  enddo ! end of do imn = 1 , mn;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(sa00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine sa00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
